Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions
kQueue Class Reference
kApi/Data

## Description

Represents a FIFO queue implemented with a dynamic array.

The kQueue class represents a dynamic, array-based queue of objects or values. The kQueue constructor accepts a kType value that determines the type of items that will be stored in the queue. The queue will automatically grow as new items are added.

kStatus QueueExample()
{
kQueue queue = kNULL;
k32s values[] = { 1, 2, 3, 5, 7, 9 };
kSize i;
kTry
{
//create a queue that can store 32-bit integers
kTest(kQueue_Construct(&queue, kTypeOf(k32s), 0, kNULL));
//add some initial items to the queue
for (i = 0; i < kCountOf(values); ++i)
{
kTest(kQueue_Add(queue, &values[i]);
}
//print some information about the queue and its items
printf("Item type: %s\n", kType_Name(kQueue_ItemType(queue)));
printf("Count: %u\n", (k32u) kQueue_Count(queue));
for (i = 0; i < kQueue_Count(queue); ++i)
{
//the kQueue_As_ macro can be used to get a queue item and cast it to the desired type;
//this is equivalent to *(k32s*)kQueue_At(queue, i);
k32s value = kQueue_As_(queue, i, k32s);
printf("Item %u: %d\n", (k32u)i, value);
}
}
kFinally
{
kObject_Destroy(queue);
kEndFinally();
}
return kOK;
}

For queues that contain objects (e.g. kImage) as opposed to values (e.g. k32s), the objects are not automatically destroyed when the queue is destroyed. To recursively destroy both the queue and the queue items, use kObject_Dispose.

kQueue supports the kObject_Clone, kObject_Dispose, and kObject_Size methods.

kQueue supports the kdat5 and kdat6 serialization protocols.

Inheritance diagram for kQueue:

## Public Member Functions
kStatus | kQueue_Add (kQueue queue, const void *item)
| Adds the specified item to the end of the queue. More...
kStatus | kQueue_AddCount (kQueue queue, kSize count)
| Increases the queue count by the specified amount. More...
kStatus | kQueue_Allocate (kQueue queue, kType itemType, kSize initialCapacity)
| Reallocates the queue item buffer. More...
kStatus | kQueue_Assign (kQueue queue, kQueue source)
| Performs a shallow copy of the source queue. More...
void * | kQueue_At (kQueue queue, kSize index)
| Returns a pointer to the specified item in the queue buffer. More...
kSize | kQueue_Capacity (kQueue queue)
| Returns the number of elements for which space has been allocated. More...
kStatus | kQueue_Clear (kQueue queue)
| Sets the count of queue items to zero. More...
kStatus | kQueue_Construct (kQueue *queue, kType itemType, kSize initialCapacity, kAlloc allocator)
| Constructs a kQueue object. More...
kSize | kQueue_Count (kQueue queue)
| Returns the current count of items in the queue. More...
kStatus | kQueue_Item (kQueue queue, kSize index, void *item)
| Gets the value of an item. More...
kSize | kQueue_ItemSize (kQueue queue)
| Returns the queue element size. More...
kType | kQueue_ItemType (kQueue queue)
| Returns the queue element type. More...
kStatus | kQueue_Purge (kQueue queue)
| Disposes any elements in the queue and sets the count of queue items to zero. More...
kStatus | kQueue_Remove (kQueue queue, void *item)
| Removes the item at the head of the queue. More...
kStatus | kQueue_RemoveCount (kQueue queue, kSize count)
| Decreases the queue count by the specified amount. More...
kStatus | kQueue_Reserve (kQueue queue, kSize capacity)
| Ensures that capacity is reserved for at least the specified number of queue items. More...
kStatus | kQueue_SetItem (kQueue queue, kSize index, const void *item)
| Sets the value of an item. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
Public Member Functions inherited from kCollection
kSize | kCollection_Count (kCollection collection)
| Gets the collection element count. More...
kIterator | kCollection_GetIterator (kCollection collection)
| Returns an iterator to the first element in the collection. More...
kBool | kCollection_HasNext (kCollection collection, kIterator iterator)
| Determines whether a collection has another item. More...
kType | kCollection_ItemType (kCollection collection)
| Gets the collection element type. More...
void * | kCollection_Next (kCollection collection, kIterator *iterator)
| Gets the next collection element and then advances the iterator. More...

## Related
#define | kQueue_AddCount_(QUEUE, C) kxQueue_AddCount_(QUEUE, C)
| Macro version of kQueue_AddCount.
#define | kQueue_RemoveCount_(QUEUE, C) kxQueue_RemoveCount_(QUEUE, C)
| Macro version of kQueue_RemoveCount.
#define | kQueue_Clear_(QUEUE) kxQueue_Clear_(QUEUE)
| Macro version of kQueue_Clear.
#define | kQueue_ItemType_(QUEUE) kxQueue_ItemType_(QUEUE)
| Macro version of kQueue_ItemType.
#define | kQueue_ItemSize_(QUEUE) kxQueue_ItemSize_(QUEUE)
| Macro version of kQueue_ItemSize.
#define | kQueue_Count_(QUEUE) kxQueue_Count_(QUEUE)
| Macro version of kQueue_Count.
#define | kQueue_Capacity_(QUEUE) kxQueue_Capacity_(QUEUE)
| Macro version of kQueue_Capacity.
#define | kQueue_At_(QUEUE, INDEX) kxQueue_At_(QUEUE, INDEX)
| Macro version of kQueue_At.
#define | kQueue_As_(QUEUE, INDEX, TYPE) kxQueue_As_(QUEUE, INDEX, TYPE)
| Accesses a queue element at the specified index, and casts the value to the specified type. More...
Related inherited from kObject
#define | kObject_Type_(OBJ) kxObject_Type_(OBJ)
| Macro version of kObject_Type.
#define | kObject_Is_(OBJ, TYPE) kxObject_Is_(OBJ, TYPE)
| Macro version of kObject_Is.
#define | kObject_Alloc_(OBJ) kxObject_Allocator_(OBJ)
| Macro version of kObject_Alloc.

The documentation for this class was generated from the following file:

- Data/kQueue.h